import com.haxepunk.HXP;
import com.haxepunk.graphics.*;
import Human;

class Scientist extends Human
{

	public var sprite: Spritemap;

	public function new(x:Float, y:Float) {
		super(x, y);

		sprite = new Spritemap("graphics/scientist.png", 94, 125);
		sprite.centerOrigin();
		graphic = sprite;

		setHitbox(50, 100, 25, 40);

		sprite.add("idle", [8]);
		sprite.add("run", [0,1,2,3,4,5,6,7], 10, true);
		sprite.add("walk", [8,9,10,11,12,13,14,15], 10, true);

		sprite.play("idle");
	}

	public override function changeState(s:HumanState) {
		super.changeState(s);
		switch(state) {
		case IDLE: sprite.play("idle");
		case PATROL: sprite.play("walk");
		case INVESTIGATE: sprite.play("run");
		case FLEE: sprite.play("run");
		case COWER: sprite.play("idle");
		case LUNCH: sprite.play("idle");
		default:
		}
	}

	public override function update() {
		if(state == DEAD) return;
		super.update();
		sprite.flipped = direction<0;
	}

	public override function die() {
		super.die();
		var flipped = sprite.flipped;
		graphic = sprite = new Spritemap("graphics/scientist_die.png", 211,133);
		sprite.centerOrigin();
		vx = 0;

		// Which way
		setHitbox(100, 50, 0, -10);
		var right: Bool = collideTypes(["solid","duct","open"], x, y)==null;
		setHitbox(100, 50, 100, -10);
		var left: Bool = collideTypes(["solid","duct","open"], x, y)==null;


		var forward = false;
		if(left && right) {
			forward = HXP.random < 0.5;
		} else forward = right != flipped;
		sprite.flipped = flipped;

		// Animation
		if(forward) {
			sprite.playFrames([0,1,2,3,4,5,6,7], 20, false);
		}
		else {
			sprite.playFrames([8,9,10,11,12,13,14,15], 20, false);
			sprite.originY -= 5;
		}
	}
}
